;================================================
; WSQ_CONST.INC file
; Constants, definitions etc.
;================================================

; Sizes of the buttons in pixels
BTNHEIGHT	equ 30	; Button height
BTNWIDTH	equ 80	; Button width
BTNFROMTOP	equ	400	; Button location from top
BTNSPACE	equ 10	; Space between buttons

; Sizes for main window
WND_HEIGHT	equ 500	; Main window height
WND_WIDTH	equ 400	; and width in px

; Constants
WM_DESTROY	equ	02h
WM_CREATE	equ 01h
WM_COMMAND	equ 0111h
WM_PAINT	equ 0Fh
WM_SIZE		equ 05h

; Window properties
CS_VREDRAW           equ 1h
CS_HREDRAW           equ 2h
CS_GLOBALCLASS       equ 4000h
WS_TABSTOP          equ 10000h
WS_SYSMENU           equ 80000h
WS_OVERLAPPED		 equ 0h
WS_CAPTION			 equ 0C00000h
WS_THICKFRAME        equ 40000h
WS_MINIMIZEBOX       equ 20000h
WS_MAXIMIZEBOX       equ 10000h
WS_OVERLAPPEDWINDOW	 equ WS_OVERLAPPED OR WS_CAPTION OR WS_SYSMENU OR WS_THICKFRAME OR WS_MINIMIZEBOX OR WS_MAXIMIZEBOX
WS_BORDER			 equ 800000h
STYLE                equ CS_HREDRAW OR CS_VREDRAW OR CS_GLOBALCLASS
BS_DEFPUSHBUTTON     equ 1h
WS_VISIBLE           equ 10000000h
WS_CHILD             equ 40000000h
WS_DISABLED			 equ 8000000h
STYLBTN              equ WS_CHILD OR WS_VISIBLE OR WS_TABSTOP
; Misc
CW_USEDEFAULT		 equ 80000000h
SRCCOPY				 equ 0CC0020h 	; For BitBlt proc (copy bitmap to DC)
; OpenFileName
OFN_FILEMUSTEXIST    equ 00001000h
OFN_PATHMUSTEXIST    equ 00000800h
OFN_LONGNAMES        equ 00200000h
OFN_EXPLORER         equ 00080000h
MAXSIZE				 equ 260
; Misc
COLOR_BACKGROUND	 equ 01h	
MB_OK				 equ 0
CrLf 				 equ 0Dh,0Ah	; New line
SM_CXSCREEN          equ 0			; Screen width
SM_CYSCREEN          equ 1			; and height for GetSystemMetrics
; Standard icon identifier
IDI_APPLICATION      equ 32512
; Cursor identifier
IDC_ARROW            equ 32512
; Window display mode -- normal
SW_SHOWNORMAL        equ 1

; --------------------------------------------------------------
; Prototypes of external procedures
; --------------------------------------------------------------
EXTERN SendMessageA@16:NEAR
EXTERN MessageBoxA@16:NEAR
EXTERN CreateWindowExA@48:NEAR
EXTERN DefWindowProcA@16:NEAR
EXTERN DispatchMessageA@4:NEAR
EXTERN ExitProcess@4:NEAR
EXTERN GetMessageA@16:NEAR
EXTERN GetModuleHandleA@4:NEAR
EXTERN LoadCursorA@8:NEAR
EXTERN LoadIconA@8:NEAR
EXTERN PostQuitMessage@4:NEAR
EXTERN RegisterClassA@4:NEAR
EXTERN ShowWindow@8:NEAR
EXTERN TranslateMessage@4:NEAR
EXTERN UpdateWindow@4:NEAR
EXTERN GetClientRect@8:NEAR
EXTERN lstrcatA@8:NEAR
EXTERN GetOpenFileNameA@4:NEAR
EXTERN GetSaveFileNameA@4:NEAR
EXTERN LoadLibraryA@4:NEAR
EXTERN GetProcAddress@8:NEAR
EXTERN FreeLibrary@4:NEAR
EXTERN GetDC@4:NEAR
EXTERN CreateCompatibleDC@4:NEAR
EXTERN SelectObject@8:NEAR
EXTERN BeginPaint@8:NEAR
EXTERN EndPaint@8:NEAR
EXTERN DeleteDC@4:NEAR
EXTERN DeleteObject@4:NEAR
EXTERN StretchBlt@44:NEAR
EXTERN BitBlt@36:NEAR
EXTERN InvalidateRect@12:NEAR
EXTERN EnableWindow@8:NEAR
EXTERN GetSystemMetrics@4:NEAR

;----------------------------------------------------------
; Structures
; ---------------------------------------------------------

; Message structure
MSGSTRUCT STRUC
    MSHWND          DD ?
    MSMESSAGE       DD ?
    MSWPARAM        DD ?
    MSLPARAM        DD ?
    MSTIME          DD ?
    MSPT            DD ?
MSGSTRUCT ENDS

; Window class structure
WNDCLASS STRUC
    CLSSTYLE        DD ?
    CLWNDPROC       DD ?
    CLSCBCLSEX      DD ?
    CLSCBWNDEX      DD ?
    CLSHINST        DD ?
    CLSHICON        DD ?
    CLSHCURSOR      DD ?
    CLBKGROUND      DD ?
    CLMENNAME       DD ?
    CLNAME          DD ?
WNDCLASS ENDS

RECT STRUCT
	LEFT			DWORD ?
	TOP				DWORD ?
	RIGHT			DWORD ?
	BOTTOM			DWORD ?	
RECT ENDS

OPENFILENAMEA STRUCT
  lStructSize        DWORD      ?
  hwndOwner          DWORD      ?
  hInstance          DWORD      ?
  lpstrFilter        DWORD      ?
  lpstrCustomFilter  DWORD      ?
  nMaxCustFilter     DWORD      ?
  nFilterIndex       DWORD      ?
  lpstrFile          DWORD      ?
  nMaxFile           DWORD      ?
  lpstrFileTitle     DWORD      ?
  nMaxFileTitle      DWORD      ?
  lpstrInitialDir    DWORD      ?
  lpstrTitle         DWORD      ?
  Flags              DWORD      ?
  nFileOffset         WORD      ?
  nFileExtension      WORD      ?
  lpstrDefExt        DWORD      ?
  lCustData          DWORD      ?
  lpfnHook           DWORD      ?
  lpTemplateName     DWORD      ?
OPENFILENAMEA ENDS

PAINTSTRUCT STRUCT
	hdc				DWORD	?
	fErase			DWORD	?
	rcPaint			RECT	<>
	fRestore		DWORD	?
	fIncUpdate		DWORD	?
	rgbReserved		BYTE	32 dup(?)
PAINTSTRUCT ENDS
