;==========================================
; WSQ_DEMO.ASM
;
; uses dinamic library WSQ_library.dll
;==========================================
.386P
.MODEL FLAT, STDCALL

; include constants, definitions etc.
include wsq_const.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\gdi32.lib

; -------------------------------------------------------------
; DATA SEGMENT
;--------------------------------------------------------------
_DATA SEGMENT
	hWnd	        DD 0			; Handle to owner window
    msg             MSGSTRUCT <?>	; Window messages struct
    WC              WNDCLASS <?>	; Windows class struct
    rec				RECT <?>		; Rect struct for main window
    OFN			    OPENFILENAMEA <?>	; Struct for GetOpenFileNameA & GetSaveFileNameA procs
    hInst           DD 0			; Handle to application instance
    TITLENAME       DB 'WSQ Demo', 0	; Pointer to window name
    CLASSNAME       DB 'CLASS32', 0		; Pointer to registered class name
    CPBUTOPEN       DB 'Open', 0	; Open button name
    CPBUTSAVE		DB 'Save', 0	; Save button name
    CPBUTREG		DB 'Register', 0 ; Register button name
    CLSBUTN         DB 'BUTTON', 0	; Button window class name

    ; Handles to button windows
    HWNDBTNOPEN     DD 0	; Open
    HWNDBTNSAVE		DD 0	; Save
    HWNDBTNREG		DD 0	; Register
    
    hDC				DD 0	; handle to DC
    hMemDC			DD 0	; handle to memory DC
    HDCBMP			DD 0 	; handle to bitmap DC
    HBMPOLD			DD 0 	; handle to old bitmap DC
    HDCPAINT		DD 0 	; handle to paint DC
    PS				PAINTSTRUCT <?>
    hBitmap			DD 0	; handle to bitmap		
        
    LIBNAME			DB 'WSQ_library.dll',0		; WSQ library name
    
    ; WSQ library names of procedures
	STR_CREATEBMP		DB '_CreateBMPFromFile',0
	STR_REGISTERWSQ		DB '_RegisterWSQ',0
	STR_PROPERTIES		DB '_SetShowFilePropertiesDialog',0
	STR_SAVE			DB '_SaveBMPToFile',0
	
	; Error messages
	ERR_DLLNOTFOUND		DB 'Cannot load library',0
	ERR_FUNCNOTFOUND	DB 'Function not found', 0
    ERR_UNKNOWN			DB 'Unknown error', 0	
    ERR_DC				DB 'DC Object error', 0

	
	; WSQ library addresses of procedures
	HCREATEBMP		DD 0	; CreateBMPFromFile address
	HREGISTERWSQ	DD 0 	; RegisterWSQ address
	HPROPS			DD 0 	; SetShowFilePropertiesDialog
	HSAVE			DD 0	; SaveBMPToFile address

	 
	HLIB			DD 0	; WSQ library wrapper address
	;HLIB_ORG		DD 0	; WSQ library address
    
    ; OPENFILENAMEA filter for open file dialog
    STR_OFILTER	 	DB 	'All images',0,'*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;',\
			   	'*.emf;*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;',\
    			   	'*.rgba;*.rgb;*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp',0,\
    			   	'FBI Wavelet Scalar Quantization (*.wsq)',0,'*.wsq',0
    			DB	'Windows bitmaps (*.bmp)',0,'*.bmp',0,\
    			   	'Macintosh TIFF images (*.tiff)',0,'*.tiff',0,\
    			   	'PC TIFF images (*.tif)',0,'*.tif',0,\
    			   	'JPG images (*.jpg)',0,'*.jpg',0
    			DB   	'JPEG-2000 Part-1 (*.jp2)',0,'*.jp2',0,\
    			   	'JPEG-2000 Code Stream (*.jpc)',0,'*.jpc',0,\
    			   	'JPE images (*.jpe)',0,'*.jpe',0,\
    			   	'JPEG images (*.jpeg)',0,'*.jpeg',0
    			DB   	'Portable network graphic images (*.png)',0,'*.png',0,\
    			   	'Compuserve Graphic Interchange Format(*.gif)',0,'*gif',0,\
    			   	'Paintshop Pro images (*.psp)',0,'*.psp',0,\
    			   	'JFIF images (*.jfif)',0,'*.jfif',0,\
    			   	'Run length encoded Windows bitmaps (*.rle)',0,'*.rle',0
    			DB   	'Device independant Windows bitmaps (*.dib)',0,'*.dib',0,\
    			   	'Truevision images (*.win)',0,'*.win',0,\
    			   	'Truevision images (*.vst)',0,'*.vst',0,\
    			   	'Truevision images (*.vda)',0,'*.vda',0
    			DB   	'Truevision images (*.tga)',0,'*.tga',0,\
    			   	'Truevision images (*.icb)',0,'*.icb',0,\
    			   	'GFI fax images (*.fax)',0,'*.fax',0,\
    			   	'Encapsulated Postscript images (*.eps)',0,'*.eps',0
    			DB   	'ZSoft Paintbrush images (*.pcx)',0,'*.pcx',0,\
    			   	'ZSoft Paintbrush images (*.pcc)',0,'*.pcc',0,\
    			   	'Word 5.x screen capture images (*.scr)',0,'*.scr',0,\
    			   	'Alias/Wavefront images (*.rpf)',0,'*.rpf',0
    			DB   	'Alias/Wavefront images (*.rla)',0,'*.rla',0,\
    			   	'SGI true color images (*.sgi)',0,'*.sgi',0,\
    			   	'SGI true color images with alpha (*.rgba)',0,'*.rgba',0,\
    			   	'SGI true color images (*.rgb)',0,'*.rgb',0,\
    			   	'SGI black/white images (*.bw)',0,'*.bw',0
    			DB   	'Photoshop images (*.psd)',0,'*.psd',0,\
    			   	'Photoshop images (*.pdd)',0,'*.pdd',0,\
    			   	'Portable pixel map images (*.ppm)',0,'*.ppm',0,\
    			   	'Portable gray map images (*.pgm)',0,'*.pgm',0
    			DB   	'Portable bitmap images (*.pbm)',0,'*.pbm',0,\
    			   	'Autodesk images (*.cel)',0,'*.cel',0,\
    			   	'Autodesk images (*.pic)',0,'*.pic',0,\
    			   	'Kodak Photo-CD images (*.pcd)',0,'*.pcd',0
    			DB   	'Dr. Halo images (*.cut)',0,'*.cut',0,\
    			   	'Amiga Bitmap Graphic (8 bits)',0,'*.iff',0,\
    			   	'Windows icons (*.ico)',0,'*.ico',0,\
    			   	'Windows metafiles (*.wmf)',0,'*.wmf',0,\
    			   	'Windows enhanced meta files (*.emf)',0,'*.emf',0,0
    

    							  
    ; OPENFILENAMEA filter for save file dialog
    STR_SFILTER		DB 	'WSQ Files (*.wsq)',0,'*.wsq',0,\
				'Windows BMP (*.bmp)',0,'*.bmp',0,\
				'TIFF Files (*.tif)',0,'*.tif',0,\
				'PNG Files (*.png)',0,'*.png',0,\
				'JPEG Files (*.jpg)',0,'*.jpg',0
			DB	'Targa Files (*.tga)',0,'*.tga',0,\
				'SGI Files (*.rgb)',0,'*.rgb',0,\
				'JPEG-2000 Part-1 (*.jp2)',0,'*.jp2',0,\
				'JPEG-2000 Code Stream (*.jpc)',0,'*.jpc',0
			DB	'PBM - Portable Bitmap Format (*.pbm)',0,'*.pbm',0,\
				'PGM - Portable Graymap Format (*.pgm)',0,'*.pgm',0,\
				'PPM - Portable Pixmap Format (*.ppm)',0,'*.ppm',0,0
    			
    			
 
    STR_FILENAME	DB	MAXSIZE DUP(0)		; Buffer for Filename (open & save)
    CAP             DB 'WSQ Demo', 0		; MessageBox caption
    BUFFER			DB	MAXSIZE DUP(0)		; Buffer for Filename
    
    wndPosX			DD 0	; Main window start position X
    wndPosY			DD 0	; and Y
    
_DATA ENDS


;----------------------------------------------------------------------------------
; CODE SEGMENT
;----------------------------------------------------------------------------------
_TEXT SEGMENT
START:
; Get screen width and height
; and calculate main window start position x,y
	PUSH			SM_CXSCREEN
	CALL			GetSystemMetrics@4
	SUB				EAX, WND_WIDTH
	SHR				EAX, 1
	MOV				[wndPosX], EAX
	
	PUSH			SM_CYSCREEN
	CALL			GetSystemMetrics@4
	SUB				EAX, WND_HEIGHT
	SHR				EAX, 1
	MOV				[wndPosY], EAX
	
; Get the application descriptor
    PUSH            0
    CALL            GetModuleHandleA@4
    MOV             [hInst], EAX
    REG_CLASS:
; Fill the window structure
; Style
    MOV  			[WC.CLSSTYLE], STYLE
; Message-handling procedure
    MOV  			[WC.CLWNDPROC], OFFSET WNDPROC
    MOV             [WC.CLSCBCLSEX], 0
    MOV             [WC.CLSCBWNDEX], 0
    MOV             EAX, [hInst]
    MOV             [WC.CLSHINST], EAX
;----------Window icon
    PUSH            IDI_APPLICATION
    PUSH            0
    CALL            LoadIconA@8
    MOV             [WC.CLSHICON], EAX
;---------- Window cursor
    PUSH            IDC_ARROW
    PUSH            0
    CALL            LoadCursorA@8
    MOV             [WC.CLSHCURSOR], EAX
;----------
    MOV             [WC.CLBKGROUND], COLOR_BACKGROUND
    MOV             DWORD PTR [WC.CLMENNAME], 0
    MOV             DWORD PTR [WC.CLNAME], OFFSET CLASSNAME
    PUSH            OFFSET WC
    CALL            RegisterClassA@4
; Create a window of the registered class 
	PUSH            0
    PUSH            [hInst]
    PUSH            0
    PUSH            0
    PUSH            WND_HEIGHT	; Window height
    PUSH            WND_WIDTH  	; and width
    PUSH            [wndPosY] ; CW_USEDEFAULT	; position y
    PUSH            [wndPosX] ; CW_USEDEFAULT	; position X
    PUSH            WS_OVERLAPPEDWINDOW
    PUSH            OFFSET TITLENAME ; Window title
    PUSH            OFFSET CLASSNAME ; Class name
    PUSH            0
    CALL            CreateWindowExA@48
; Check for error
    CMP             EAX, 0
    JZ              _ERR
	MOV  	       [hWnd], EAX
;--------------------------------
    PUSH            SW_SHOWNORMAL
    PUSH            [hWnd]
    CALL            ShowWindow@8
;--------------------------------
	PUSH            [hWnd]
    CALL            UpdateWindow@4
; Message-handling loop
MSG_LOOP:
    PUSH            0
    PUSH            0
    PUSH            0
    PUSH            OFFSET msg
    CALL            GetMessageA@16
    CMP             EAX, 0
    JE              END_LOOP
    PUSH            OFFSET msg
    CALL            TranslateMessage@4
    PUSH            OFFSET msg
    CALL            DispatchMessageA@4
    JMP             MSG_LOOP
END_LOOP:
; Exit the program (close the process)
    PUSH            [msg.MSWPARAM]
    CALL            ExitProcess@4
_ERR:
	JMP             END_LOOP
;-------------------------------Window procedure
; Position of parameters in the stack
; [EBP+014H] ; LPARAM
; [EBP+10H]  ; WAPARAM
; [EBP+0CH]  ; MES
; [EBP+8]    ; HWND 
WNDPROC PROC
	PUSH            EBP
    MOV             EBP, ESP
    PUSH            EBX
    PUSH            ESI
    PUSH            EDI
    CMP             DWORD PTR [EBP+0CH], WM_DESTROY
    JE              WMDESTROY
    CMP             DWORD PTR [EBP+0CH], WM_CREATE
    JE              WMCREATE
    CMP             DWORD PTR [EBP+0CH], WM_PAINT
    JE              WMPAINT
    CMP             DWORD PTR [EBP+0CH], WM_SIZE
    JE              WMRESIZE
    CMP             DWORD PTR [EBP+0CH], WM_COMMAND
    JE              WMCOMMND
    JMP             DEFWNDPROC
;------------------------------------------------------
WMRESIZE:
	; Get main window rect
	PUSH			OFFSET rec
	PUSH			DWORD PTR [EBP+08h]
	CALL			GetClientRect@8
	CMP				EAX, 0
	JZ				UNKNOWN_ERROR
	
	XOR				EAX, EAX
	JMP				FINISH
;------------------------------------------------------	
WMPAINT:
	PUSH			OFFSET PS
	PUSH			[hWnd]
	CALL			BeginPaint@8
	CMP				EAX, 0
	JE				UNKNOWN_ERROR
	MOV				[hDC], EAX
	
	; hDC & HDCBMP == NULL?, if yes, close app
	CMP				[hDC], 0
    JE				UNKNOWN_ERROR
    CMP				[HDCBMP], 0
    JE				UNKNOWN_ERROR
    
    ; not NULL, continue
    PUSH	[hDC]
    CALL	CreateCompatibleDC@4
    CMP		EAX, 0
    JE		DC_ERROR
    MOV		[hMemDC], EAX
    CMP		[hBitmap], 0	; Is bitmap loaded?
    JE		L3				; Not yet, skip processing
    
    PUSH	[hBitmap]	; Handle of object HBITMAP  
    PUSH	[hMemDC]	; Handle of device context 
    CALL	SelectObject@8
    CMP		EAX, 0
    JE		DC_ERROR
    MOV		[HBMPOLD], EAX ; Save old object
	    
	; Copy bitmap to DC    
    PUSH	SRCCOPY
    PUSH	0
    PUSH	0
    PUSH	[hMemDC]
    PUSH	[rec.bottom]
    PUSH	[rec.right]
    PUSH	0
    PUSH	0
    PUSH	[hDC]
    CALL 	BitBlt@36
    CMP		EAX, 0
    JE		DC_ERROR
 
L3: ; Bitmap not loaded yet
	PUSH	[hMemDC]
	CALL	DeleteDC@4

	PUSH			OFFSET PS
	PUSH			[hWnd]
	CALL			EndPaint@8
	CMP				EAX, 0
	JE				UNKNOWN_ERROR
	
	XOR				EAX, EAX
	JMP				FINISH
;------------------------------------------------------	
WMCOMMND:
	MOV				EAX, HWNDBTNOPEN
	CMP				DWORD PTR [EBP+14h], EAX
	JE				CMDBTNOPEN
	MOV				EAX, HWNDBTNSAVE
	CMP				DWORD PTR [EBP+14h], EAX
	JE				CMDBTNSAVE
	MOV				EAX, HWNDBTNREG
	CMP				DWORD PTR [EBP+14h], EAX
	JE				CMDBTNREG
	XOR				EAX, EAX
	JMP				FINISH
	CMDBTNOPEN:
	; OpenFile dialog
		MOV				[STR_FILENAME], 0
		MOV				[BUFFER], 0	
	
		MOV				[OFN.lStructSize], SIZEOF OFN
		PUSH			[hWnd]
		POP				[OFN.hwndOwner]
		PUSH			[hInst]
		POP				[OFN.hInstance]		
		MOV				[OFN.nFilterIndex], 1		
		MOV				[OFN.lpstrFilter], OFFSET STR_OFILTER
		MOV				[OFN.lpstrFile], OFFSET BUFFER
		MOV				[OFN.nMaxFile], MAXSIZE
		MOV				[OFN.Flags], OFN_FILEMUSTEXIST OR OFN_PATHMUSTEXIST OR \
									 OFN_LONGNAMES OR OFN_EXPLORER
		PUSH			OFFSET OFN
		CALL			GetOpenFileNameA@4
		CMP				EAX, 0
		JE				FINISH
		
		; Copy filename to variable
		MOV				[STR_FILENAME], 0
		PUSH			[OFN.lpstrFile]
		PUSH			OFFSET STR_FILENAME
		CALL			lstrcatA@8
		
		PUSH			OFFSET STR_FILENAME
		CALL			[HCREATEBMP]	; CreateBMPFrmFile
		ADD				ESP, 4
		CMP				EAX, 0
		JE				UNKNOWN_ERROR		; Error loading image
		MOV				[hBitmap], EAX
		
		; Enable 'Save' button
		PUSH			1	; TRUE - enable
    	PUSH			[HWNDBTNSAVE]
    	CALL			EnableWindow@8
		
		PUSH			1	; TRUE - erase background
		PUSH			0
		PUSH			[hWnd]
		CALL			InvalidateRect@12
    	
 		XOR				EAX, EAX
		JMP				FINISH

	CMDBTNSAVE:
	; OpenFile dialog
		MOV				[STR_FILENAME], 0
		MOV				[BUFFER], 0
		
		MOV				[OFN.lStructSize], SIZEOF OFN
		PUSH			[hWnd]
		POP				[OFN.hwndOwner]
		PUSH			[hInst]
		POP				[OFN.hInstance]
		MOV				[OFN.nFilterIndex], 1		
		MOV				[OFN.lpstrFilter], OFFSET STR_SFILTER
		MOV				[OFN.lpstrFile], OFFSET BUFFER
		MOV				[OFN.nMaxFile], MAXSIZE
		MOV				[OFN.Flags], OFN_FILEMUSTEXIST OR OFN_PATHMUSTEXIST OR \
									 OFN_LONGNAMES OR OFN_EXPLORER
		PUSH			OFFSET OFN
		CALL			GetSaveFileNameA@4
		CMP				EAX, 0
		JE				FINISH
		
		PUSH			[OFN.lpstrFile]
		PUSH			OFFSET STR_FILENAME
		CALL			lstrcatA@8

		; Set WSQ File property dialog
		PUSH			1
		CALL 			[HPROPS]
		ADD				ESP, 4
		
		; Save BMP to file
		CMP				[hBitmap], 0
		JE				FINISH
		PUSH			[OFN.nFilterIndex]
		PUSH			OFFSET STR_FILENAME
		PUSH			[hBitmap]
		CALL			[HSAVE]
		ADD				ESP, 12
		CMP				EAX, 0
		JE				UNKNOWN_ERROR
				
	
		XOR		EAX, EAX
		JMP		FINISH
	CMDBTNREG:
   	; RegisterWSQ
   		CALL	[HREGISTERWSQ]
		XOR		EAX, EAX
		JMP		FINISH
;------------------------------------------------------
WMCREATE:
; Get main window rect
	PUSH			OFFSET rec
	PUSH			DWORD PTR [EBP+08h]
	CALL			GetClientRect@8
	CMP				EAX, 0
	JZ				UNKNOWN_ERROR

	; Load DLL STDCALL
	PUSH	OFFSET LIBNAME
	CALL	LoadLibraryA@4
	CMP		EAX, 0
	JE		DLL_LOAD_ERROR
	MOV		[HLIB], EAX

	; Get RegisterWSQ address
   	PUSH	OFFSET STR_REGISTERWSQ
   	PUSH	[HLIB]
   	CALL	GetProcAddress@8
   	CMP		EAX, 0
   	JE		FUNC_NOT_FOUND
   	; RegisterWSQ
   	MOV		HREGISTERWSQ, EAX

   ; Get LoadBMPFromFile address
	PUSH	OFFSET STR_CREATEBMP
	PUSH	[HLIB]
	CALL	GetProcAddress@8
	CMP		EAX, 0
	JE		FUNC_NOT_FOUND
	MOV		HCREATEBMP, EAX
	
	; Get void SetShowFilePropertiesDialog(int file_properties_dialog) address
	PUSH	OFFSET STR_PROPERTIES
	PUSH	[HLIB]
	CALL	GetProcAddress@8
	CMP		EAX, 0
	JE		FUNC_NOT_FOUND
	MOV		HPROPS, EAX
	
	; Get SaveBMPToFile(HBITMAP hBitmap, const char *filename, int filetype)
	PUSH 	OFFSET STR_SAVE
	PUSH	[HLIB]
	CALL	GetProcAddress@8
	CMP		EAX, 0
	JE		FUNC_NOT_FOUND
	MOV		HSAVE, EAX
	

; Create button 'Open'
    PUSH            0
    PUSH            [hInst]
    PUSH            0
    PUSH            DWORD PTR [EBP+08H]
    PUSH            BTNHEIGHT ; DY
    PUSH            BTNWIDTH ; DX
    PUSH            BTNFROMTOP ; Y
    PUSH            BTNSPACE ; X
    PUSH            STYLBTN
    PUSH            OFFSET CPBUTOPEN
    PUSH            OFFSET CLSBUTN
    PUSH            0
    CALL            CreateWindowExA@48
    MOV             HWNDBTNOPEN, EAX
 
; Create button 'Save'
    PUSH            0
    PUSH            [hInst]
    PUSH            0
    PUSH            DWORD PTR [EBP+08H]
    PUSH            BTNHEIGHT ; DY
    PUSH            BTNWIDTH ; DX
    PUSH            BTNFROMTOP ; Y
    PUSH            BTNSPACE+BTNSPACE+BTNWIDTH ; X
    PUSH            STYLBTN;+WS_DISABLED
    PUSH            OFFSET CPBUTSAVE
    PUSH            OFFSET CLSBUTN
    PUSH            0
    CALL            CreateWindowExA@48
    MOV             HWNDBTNSAVE, EAX
    
; Create button 'Register'
    PUSH            0
    PUSH            [hInst]
    PUSH            0
    PUSH            DWORD PTR [EBP+08H]
    PUSH            BTNHEIGHT ; DY
    PUSH            BTNWIDTH ; DX
    PUSH            BTNFROMTOP+BTNHEIGHT+BTNSPACE ; Y
    PUSH            BTNSPACE ; X
    PUSH            STYLBTN
    PUSH            OFFSET CPBUTREG
    PUSH            OFFSET CLSBUTN
    PUSH            0
    CALL            CreateWindowExA@48
    MOV             HWNDBTNREG, EAX
    
    ; Initially disable 'Save' button
    PUSH			0
    PUSH			[HWNDBTNSAVE]
    CALL			EnableWindow@8

; Get DC address
   	PUSH	[hWnd]
   	CALL	GetDC@4
   	MOV		[hDC], EAX
   	CMP		EAX, 0
   	JE		DC_ERROR
    	
   	PUSH	[hDC]
   	CALL	CreateCompatibleDC@4
   	CMP		EAX, 0
   	JE		DC_ERROR
   	MOV		[HDCBMP], EAX
    	
	XOR		EAX, EAX
    JMP		FINISH    
;------------------------------------------------------	    
DEFWNDPROC:
	PUSH            DWORD PTR [EBP+14H]
    PUSH            DWORD PTR [EBP+10H]
    PUSH            DWORD PTR [EBP+0CH]
    PUSH            DWORD PTR [EBP+08H]
    CALL            DefWindowProcA@16
    JMP             FINISH
;------------------------------------------------------    
WMDESTROY:
	; Delete DC
    PUSH	[HDCBMP]
    CALL	DeleteDC@4
    CMP		EAX, 0
	JE		DC_ERROR
	; Free WSQ library wrapper
    PUSH	[HLIB]
    CALL	FreeLibrary@4
    CMP		EAX, 0
    JE		UNKNOWN_ERROR
   	
   	; hBitmap == NULL ?
   	CMP				[hBitmap], 0
	JE				L2 ; yes, skip delete object
	PUSH			[hBitmap]
	CALL			DeleteObject@4
L2:
    PUSH            0
    CALL            PostQuitMessage@4
    XOR             EAX, EAX
;------------------------------------------------------    
FINISH:
	POP				EDI
    POP				ESI
    POP				EBX
    POP				EBP
	RET				16
;------------------------------------------------------
; Error messages
;------------------------------------------------------
DLL_LOAD_ERROR:
    MOV		EBX, OFFSET ERR_DLLNOTFOUND
    CALL	ShowMsg
	JMP		FINISH
FUNC_NOT_FOUND:
    MOV		EBX, OFFSET ERR_FUNCNOTFOUND
    CALL	ShowMsg
	JMP		FINISH
UNKNOWN_ERROR:
    MOV		EBX, OFFSET ERR_UNKNOWN
    CALL	ShowMsg
    PUSH    0
    CALL    PostQuitMessage@4 ; WM_QUIT message
    XOR     EAX, EAX
    JMP		FINISH
DC_ERROR:
    MOV		EBX, OFFSET ERR_DC
    CALL	ShowMsg
    PUSH    0
    CALL    PostQuitMessage@4 ; WM_QUIT message
    XOR     EAX, EAX
    JMP		FINISH
;--------------------------------------------------------    
WNDPROC ENDP   ; End WNDPROC

; -------------------------------------------------------
; MessageBox procedure
; Input: EBX - address of string to show
; -------------------------------------------------------
ShowMsg PROC
	PUSH            MB_OK
    PUSH            OFFSET CAP
    PUSH            EBX
    PUSH			[hWnd]
    CALL            MessageBoxA@16	
	RET
ShowMsg ENDP

_TEXT ENDS
END START